package androidsalsa.resources;

import android.app.Activity;
import android.os.Handler;
import android.widget.TextView;

public class AndroidProxy {
	private static Activity context = null;
	private static TextView textView = null;

	// to be called from Android Apps
	public static void setTextViewContext( Activity context, TextView textView ) {
		AndroidProxy.context = context;
		AndroidProxy.textView = textView;
	}

	// to be called from Salsa Apps
	public static boolean postText( final String str ) {
		if ((AndroidProxy.context == null) || (AndroidProxy.textView == null)){
			System.err.println( "valid context not set in AndroidProxy class" );
			return false;
		}

		context.runOnUiThread( new Runnable() {
			public void run() {
					AndroidProxy.textView.append( str );
			}
		});

		return true;
	}
}

    