package examples.Heat;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import gc.WeakReference;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

import salsa.resources.SystemService;

import salsa.resources.ActorService;

// End SALSA compiler generated import delcarations.

import java.io.*;
import java.util.*;

public class DistributedHeat extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		RunTime.receivedMessage();
		DistributedHeat instance = (DistributedHeat)new DistributedHeat(uan, ual,null).construct();
		gc.WeakReference instanceRef=new gc.WeakReference(uan,ual);
		{
			Object[] _arguments = { args };

			//preAct() for local actor creation
			//act() for remote actor creation
			if (ual != null && !ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {instance.send( new Message(instanceRef, instanceRef, "act", _arguments, false) );}
			else {instance.send( new Message(instanceRef, instanceRef, "preAct", _arguments, false) );}
		}
		RunTime.finishedProcessingMessage();
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new DistributedHeat(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return DistributedHeat.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new DistributedHeat(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return DistributedHeat.getReferenceByLocation(new UAL(ual)); }
	public DistributedHeat(boolean o, UAN __uan)	{ super(false,__uan); }
	public DistributedHeat(boolean o, UAL __ual)	{ super(false,__ual); }
	public DistributedHeat(UAN __uan,UniversalActor.State sourceActor)	{ this(__uan, null, sourceActor); }
	public DistributedHeat(UAL __ual,UniversalActor.State sourceActor)	{ this(null, __ual, sourceActor); }
	public DistributedHeat(UniversalActor.State sourceActor)		{ this(null, null, sourceActor);  }
	public DistributedHeat()		{  }
	public DistributedHeat(UAN __uan, UAL __ual, Object obj) {
		//decide the type of sourceActor
		//if obj is null, the actor must be the startup actor.
		//if obj is an actorReference, this actor is created by a remote actor

		if (obj instanceof UniversalActor.State || obj==null) {
			  UniversalActor.State sourceActor;
			  if (obj!=null) { sourceActor=(UniversalActor.State) obj;}
			  else {sourceActor=null;}

			  //remote creation message sent to a remote system service.
			  if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			    WeakReference sourceRef;
			    if (sourceActor!=null && sourceActor.getUAL() != null) {sourceRef = new WeakReference(sourceActor.getUAN(),sourceActor.getUAL());}
			    else {sourceRef = null;}
			    if (sourceActor != null) {
			      if (__uan != null) {sourceActor.getActorMemory().getForwardList().putReference(__uan);}
			      else if (__ual!=null) {sourceActor.getActorMemory().getForwardList().putReference(__ual);}

			      //update the source of this actor reference
			      setSource(sourceActor.getUAN(), sourceActor.getUAL());
			      activateGC();
			    }
			    createRemotely(__uan, __ual, "examples.Heat.DistributedHeat", sourceRef);
			  }

			  // local creation
			  else {
			    State state = new State(__uan, __ual);

			    //assume the reference is weak
			    muteGC();

			    //the source actor is  the startup actor
			    if (sourceActor == null) {
			      state.getActorMemory().getInverseList().putInverseReference("rmsp://me");
			    }

			    //the souce actor is a normal actor
			    else if (sourceActor instanceof UniversalActor.State) {

			      // this reference is part of garbage collection
			      activateGC();

			      //update the source of this actor reference
			      setSource(sourceActor.getUAN(), sourceActor.getUAL());

			      /* Garbage collection registration:
			       * register 'this reference' in sourceActor's forward list @
			       * register 'this reference' in the forward acquaintance's inverse list
			       */
			      String inverseRefString=null;
			      if (sourceActor.getUAN()!=null) {inverseRefString=sourceActor.getUAN().toString();}
			      else if (sourceActor.getUAL()!=null) {inverseRefString=sourceActor.getUAL().toString();}
			      if (__uan != null) {sourceActor.getActorMemory().getForwardList().putReference(__uan);}
			      else if (__ual != null) {sourceActor.getActorMemory().getForwardList().putReference(__ual);}
			      else {sourceActor.getActorMemory().getForwardList().putReference(state.getUAL());}

			      //put the inverse reference information in the actormemory
			      if (inverseRefString!=null) state.getActorMemory().getInverseList().putInverseReference(inverseRefString);
			    }
			    state.updateSelf(this);
			    ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			    if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
			  }
		}

		//creation invoked by a remote message
		else if (obj instanceof ActorReference) {
			  ActorReference sourceRef= (ActorReference) obj;
			  State state = new State(__uan, __ual);
			  muteGC();
			  state.getActorMemory().getInverseList().putInverseReference("rmsp://me");
			  if (sourceRef.getUAN() != null) {state.getActorMemory().getInverseList().putInverseReference(sourceRef.getUAN());}
			  else if (sourceRef.getUAL() != null) {state.getActorMemory().getInverseList().putInverseReference(sourceRef.getUAL());}
			  state.updateSelf(this);
			  ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(),state);
			  if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor .State {
		public DistributedHeat self;
		public void updateSelf(ActorReference actorReference) {
			((DistributedHeat)actorReference).setUAL(getUAL());
			((DistributedHeat)actorReference).setUAN(getUAN());
			self = new DistributedHeat(false,getUAL());
			self.setUAN(getUAN());
			self.setUAL(getUAL());
			self.activateGC();
		}

		public void preAct(String[] arguments) {
			getActorMemory().getInverseList().removeInverseReference("rmsp://me",1);
			{
				Object[] __args={arguments};
				self.send( new Message(self,self, "act", __args, null,null,false) );
			}
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.Heat.DistributedHeat$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				if (!message.getMethodName().equals("die")) {activateArgsGC(message);}
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		int iterations = 100;
		int x = 120;
		int y = 120;
		int actors = 2;
		long initialTime;
		String nameServer = "n1.ns.cs.rpi.edu";
		String theatersFile = "cluster.txt";
		String fileName = "heat-salsa.map";
		public double[][] createInitialData() {
			double[][] data = new double[x][];
			for (int i = 0; i<x; i++){
				data[i] = new double[y];
				for (int j = 0; j<y; j++){
					data[i][j] = 20.0;
					if (i==0||j==0||i==x-1||j==y-1) {data[i][j] = 20.0;
}					if (j==0&&i>x/4&&i<3*x/4) {data[i][j] = 100.0;
}				}
			}
			return data;
		}
		public void produceFile(double[][] data, String fileName) {
			try {
				PrintWriter out = new PrintWriter(new FileWriter(fileName));
				out.println(x+" "+y);
				for (int i = 0; i<x; i++){
					for (int j = 0; j<y; j++)					try {
						out.println(data[i][j]);
					}
					catch (Exception e) {
continue;					}

				}
				out.flush();
				out.close();
			}
			catch (IOException ioe) {
				{
					// standardOutput<-println("[error] Can't open the file "+fileName+" for writing.")
					{
						Object _arguments[] = { "[error] Can't open the file "+fileName+" for writing." };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}

		}
		public double[][] doWork(double[][] data, int iterations, int noActors, String nameServer, String theatersFile) {
			int rowsPerActor = x/noActors;
			HeatWorker[] workers = new HeatWorker[noActors];
			for (int a = 0; a<noActors; a++){
				int i = a*rowsPerActor;
				double[][] workerData = new double[rowsPerActor][];
				for (int j = 0; j<rowsPerActor; j++){
					workerData[j] = new double[y];
					System.arraycopy(data[i], 0, workerData[j], 0, y);
					i++;
				}
				workers[a] = ((HeatWorker)new HeatWorker(new UAN("uan://"+nameServer+":3030/a"+a), null,this).construct(workerData));
			}
			{
				// standardOutput<-println(((DistributedHeat)self)+" connecting worker neighbors")
				{
					Object _arguments[] = { ((DistributedHeat)self)+" connecting worker neighbors" };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			for (int a = 0; a<noActors; a++){
				if (a>0) {				{
					// workers[a]<-connectTop(workers[a-1])
					{
						Object _arguments[] = { workers[a-1] };
						Message message = new Message( self, workers[a], "connectTop", _arguments, null, null );
						__messages.add( message );
					}
				}
}				if (a<noActors-1) {				{
					// workers[a]<-connectBottom(workers[a+1])
					{
						Object _arguments[] = { workers[a+1] };
						Message message = new Message( self, workers[a], "connectBottom", _arguments, null, null );
						__messages.add( message );
					}
				}
}			}
			Vector theaters = new Vector();
			String theater;
			try {
				BufferedReader in = new BufferedReader(new FileReader(theatersFile));
				while ((theater=in.readLine())!=null) {
					theaters.add(theater);
				}
				in.close();
			}
			catch (IOException ioe) {
				{
					// standardOutput<-println("[error] Can't open the file "+fileName+" for writing.")
					{
						Object _arguments[] = { "[error] Can't open the file "+fileName+" for writing." };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}

			for (int a = 0; a<noActors; a++){
				{
					// standardOutput<-println("Sending actor "+"uan://"+nameServer+":3030/a"+a+" to "+"rmsp://"+theaters.get(a%theaters.size())+"/a"+a)
					{
						Object _arguments[] = { "Sending actor "+"uan://"+nameServer+":3030/a"+a+" to "+"rmsp://"+theaters.get(a%theaters.size())+"/a"+a };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
				{
					// workers[a]<-migrate("rmsp://"+theaters.get(a%theaters.size())+"/a"+a)
					{
						Object _arguments[] = { "rmsp://"+theaters.get(a%theaters.size())+"/a"+a };
						Message message = new Message( self, workers[a], "migrate", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			{
				// standardOutput<-println(">>>>>>Starting the computation")
				{
					Object _arguments[] = { ">>>>>>Starting the computation" };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			initialTime = System.currentTimeMillis();
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int a = 0; a<noActors; a++)				{
					// workers[a]<-doWork(new Integer(iterations))
					{
						Object _arguments[] = { new Integer(iterations) };
						Message message = new Message( self, workers[a], "doWork", _arguments, null, token_2_0 );
						__messages.add( message );
					}
				}
				addJoinToken(token_2_0);
				// composeMatrix(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "composeMatrix", _arguments, token_2_0, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
		public void endTimer() {
			long finalTime = System.currentTimeMillis();
			long runningTime = finalTime-initialTime;
			double processingRate = 1.0*iterations*(x-2)*(y-2)/runningTime;
			{
				// standardOutput<-println("Time for "+iterations+" iterations on "+(x-2)+","+(y-2)+" grid: "+runningTime+" ms.")
				{
					Object _arguments[] = { "Time for "+iterations+" iterations on "+(x-2)+","+(y-2)+" grid: "+runningTime+" ms." };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			{
				// standardOutput<-println("Execution rate: "+processingRate+" points/ms")
				{
					Object _arguments[] = { "Execution rate: "+processingRate+" points/ms" };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public double[][] composeMatrix(Object[] results) {
			double[][] cresults;
			double[][] m = new double[x][];
			int i = 0;
			for (int a = 0; a<results.length; a++){
				cresults = (double[][])results[a];
				for (int j = 0; j<cresults.length; j++){
					m[i] = new double[y];
					System.arraycopy(cresults[j], 0, m[i], 0, y);
					i++;
				}
			}
			{
				// endTimer()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "endTimer", _arguments, null, null );
					__messages.add( message );
				}
			}
			{
				// standardOutput<-println("Returned matrix size:"+m.length+","+m[0].length)
				{
					Object _arguments[] = { "Returned matrix size:"+m.length+","+m[0].length };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			return m;
		}
		public void act(String args[]) {
			int argc = args.length;
			if (argc>=1) {iterations = Integer.parseInt(args[0]);
};			if (argc>=2) {x = Integer.parseInt(args[1]);
}			if (argc>=3) {y = Integer.parseInt(args[2]);
}			if (argc>=4) {actors = Integer.parseInt(args[3]);
}			if (argc>=5) {nameServer = args[4];
}			if (argc>=6) {theatersFile = args[5];
}			if (argc>=7) {fileName = args[6];
}			x += 2;
			y += 2;
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				// createInitialData()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "createInitialData", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// doWork(token, new Integer(iterations), new Integer(actors), nameServer, theatersFile)
				{
					Object _arguments[] = { token_2_0, new Integer(iterations), new Integer(actors), nameServer, theatersFile };
					Message message = new Message( self, self, "doWork", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// produceFile(token, fileName)
				{
					Object _arguments[] = { token_2_1, fileName };
					Message message = new Message( self, self, "produceFile", _arguments, token_2_1, token_2_2 );
					__messages.add( message );
				}
				// standardOutput<-println("Computation is done")
				{
					Object _arguments[] = { "Computation is done" };
					Message message = new Message( self, standardOutput, "println", _arguments, token_2_2, null );
					__messages.add( message );
				}
			}
		}
	}
}